#include "bg.h"
#include "gbfs.h"
#include "../res.h"


//bg0 ASCII
//bg1 ݂tHg
//bg2 None
//bg3 None

//---------------------------------------------------------------------------
ST_BG      Bg[BG_MAX_CNT];
ST_BG_SJIS BgSjis;


//---------------------------------------------------------------------------
EWRAM_CODE void BgInit()
{
	BgInitLcd();

	Bg0Init();
	Bg1Init();
	Bg2Init();
	Bg3Init();

	BgAsciiInit();
	BgSjisInit();

	REG_DISPCNT = (MODE_0 | BG0_ON | BG1_ON | BG2_ON);
	REG_BG0CNT  = (BG_SIZE_0 | BG_16_COLOR | Bg[0].tileBase | Bg[0].mapBase | 0);
	REG_BG1CNT  = (BG_SIZE_0 | BG_16_COLOR | Bg[1].tileBase | Bg[1].mapBase | 0);
	REG_BG2CNT  = (BG_SIZE_0 | BG_16_COLOR | Bg[2].tileBase | Bg[2].mapBase | 2 | BG_WRAP);
//	REG_BG3CNT  = (BG_SIZE_0 | BG_16_COLOR | Bg[3].tileBase | Bg[3].mapBase | 3 | BG_WRAP);
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgInitLcd()
{
	const u16 mapBase[]  = { 29, 30, 31,  0 };
	const u16 tileBase[] = {  0,  1,  3,  0 };
	u32 i;

	for(i=0; i<BG_MAX_CNT; i++)
	{
		Bg[i].mapBase     = MAP_BASE(mapBase[i]);
		Bg[i].mapBaseAdr  = MAP_BASE_ADR(mapBase[i]);
		Bg[i].tileBase    = TILE_BASE(tileBase[i]);
		Bg[i].tileBaseAdr = TILE_BASE_ADR(tileBase[i]);
	}

	for(i=0; i<32*32; i++)
	{
		Bg[0].mapBaseAdr[i] = 0;
		Bg[1].mapBaseAdr[i] = 0;
		Bg[2].mapBaseAdr[i] = 0;
		Bg[3].mapBaseAdr[i] = 0;
	}

	for(i=0; i<0x2000; i++)
	{
		Bg[0].tileBaseAdr[i] = 0;
		Bg[1].tileBaseAdr[i] = 0;
		Bg[2].tileBaseAdr[i] = 0;
		Bg[3].tileBaseAdr[i] = 0;
	}
}
//---------------------------------------------------------------------------
// ASCIItHgݒ肵܂
EWRAM_CODE void Bg0Init()
{
/*
	u16 i;

	for(i=0; i<4096; i++)
	{
		Bg[0].tileBaseAdr[i] = font_asciiTiles[i];
	}

	for(i=0; i<16; i++)
	{
		BG_PALETTE[i+16]  = font_asciiPal[i];
	}
*/
}
//---------------------------------------------------------------------------
// ݂tHgݒ肵܂
EWRAM_CODE void Bg1Init()
{
/*
	u16 i;

	for(i=0; i<32*32; i++)
	{
		Bg[1].mapBaseAdr[i] = i + (2<<12);
	}

	for(i=0; i<16; i++)
	{
		BG_PALETTE[i+32] = font_mikaPal[i];
	}
*/
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bg2Init()
{
/*
	u16* pImg = GBFSGetSafePointer("bg.img");
	u16* pPal = GBFSGetSafePointer("bg.pal");
	u16  i;

	for(i=0; i<0x1000/2; i++)
	{
		Bg[2].tileBaseAdr[i] = pImg[i];
	}

	for(i=0; i<16; i++)
	{
		BG_PALETTE[i+48] = pPal[i];
	}
*/
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bg3Init()
{
	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgAsciiInit()
{
	// EMPTY
}
//---------------------------------------------------------------------------
IWRAM_CODE void BgAsciiDrawStr(u16 x, u16 y, char* s)
{
	u16* map = &Bg[0].mapBaseAdr[x + y * 32];

	while(*s != NULL)
	{
		*map++ = (*s++ - ' ') + (1<<12);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgSjisInit()
{
	_Memset((u8*)&BgSjis, 0x00, sizeof(ST_BG_SJIS));


//	BgSjis.pDat = (u16*)&font_mikaTiles;
//	BgSjis.pCct = (u8*)&cct_mika_bin + sizeof(ST_CCT_HEAD);
}
//---------------------------------------------------------------------------
IWRAM_CODE void BgSjisDrawStr(u16 x, u16 y, char* str)
{
	u16 i = 0;
	u16 chr;

	for(;;)
	{
		chr = str[i++];

		if(chr == '\0' || chr == CR || chr == LF)
		{
			return;
		}

		if(_IsDigit(chr) == TRUE)
		{
			chr = 0x824f + chr - '0';
		}
		else
		{
			chr = (chr << 8) | str[i++];
		}

		BgSjisDrawChr(x, y, chr);
		x++;

		if(x >= BG_FONT_SCX)
		{
			x = 0;
			y++;

			if(y >= BG_FONT_SCY)
			{
				return;
			}
		}
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void BgSjisDrawChr(u16 x, u16 y, u16 chr)
{
	u16 idx = BgSjisGetIdx(chr);
	u16 i;

	u16* s1 = BgSjis.pDat + idx * BG_FONT_DAT_SIZE / 2;
	u16* s2 = s1 + 32 / 2;
	u16* s3 = s2 + 32 / 2;
	u16* s4 = s3 + 32 / 2;

	if(x & 0x1)
	{
		u16* d1 = Bg[1].tileBaseAdr + y*1024 + (((((x+1)/2)*3)-2) * 32 / 2) + 1;
		u16* d2 = d1 + 15;
		u16* d3 = d1 + 512;
		u16* d4 = d2 + 512;

		for(i=0; i<8; i++)
		{
			*d1++ = *s1++;
			d1++;

			*d2++ = *s1++;
			*d2++ = *s2++;
			s2++;
		}

		for(i=0; i<8; i++)		//]`悵ȂȂ6
		{
			*d3++ = *s3++;
			d3++;

			*d4++ = *s3++;
			*d4++ = *s4++;
			s4++;
		}
	}
	else
	{
		u16* d1 = Bg[1].tileBaseAdr + y*1024 + ((x/2)*3) * 32 / 2;
		u16* d2 = d1 + 32 / 2;
		u16* d3 = d1 + 512;
		u16* d4 = d3 + 32 / 2;

		for(i=0; i<8; i++)
		{
			*d1++ = *s1++;
			*d1++ = *s1++;

			*d2++ = *s2++;
			d2++;
			s2++;
		}

		for(i=0; i<8; i++)		//]`悵ȂȂ6
		{
			*d3++ = *s3++;
			*d3++ = *s3++;

			*d4++ = *s4++;
			d4++;
			s4++;
		}
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE u16 BgSjisGetIdx(u16 code)
{
	if(_IsSJIS(HIBYTE(code)) == FALSE)
	{
		return BG_FONT_INVALID_INDEX;
	}


	// level 1 ---------------------------------
	u16 c0 = HIBYTE(code) >> 5;
	u16 c1 = HIBYTE(code) & 0x1f;
	u16 i1;

	if(c0 == 4)
	{
		// 80-9F
		i1 = ((u16*)BgSjis.pCct)[c1];
	}
	else
	{
		// E0-FF
		i1 = ((u16*)BgSjis.pCct)[c1 + 32];
	}

	if(i1 == 0)
	{
		return BG_FONT_INVALID_INDEX;
	}


	// level 2 ---------------------------------
	u16 c2 = LOBYTE(code) >> 6;
	u16 i2 = ((u16*)(BgSjis.pCct + i1))[c2];

	if(i2 == 0)
	{
		return BG_FONT_INVALID_INDEX;
	}

	ST_CCT_ENT*  pXcctEnt  = (ST_CCT_ENT*)(BgSjis.pCct + i2);
	ST_CCT_INFO* pXcctInfo = (ST_CCT_INFO*)(BgSjis.pCct + i2 + sizeof(ST_CCT_ENT));


	// level 3 ---------------------------------
	u16 c3 = LOBYTE(code) & 0x3f;
	u16 i;

	for(i=0; i<pXcctEnt->count; i++)
	{
		if(c3 >= pXcctInfo->start && c3 <= pXcctInfo->end)
		{
			return pXcctInfo->offset + (c3 - pXcctInfo->start);
		}

		pXcctInfo++;
	}

	return BG_FONT_INVALID_INDEX;
}
