#include "spr.h"
#include "gbfs.h"
#include "dma_arm.h"
#include "../res.h"


//---------------------------------------------------------------------------
ST_SPR    Spr;
ST_SPRITE SprCur;

// ../libgba/common.c
extern u32 dummy;

//---------------------------------------------------------------------------
EWRAM_CODE void SprInit()
{
	_Memset(&Spr, 0x00, sizeof(ST_SPR));

	SprInitDat();
	SprInitPal();

	REG_DISPCNT |= (OBJ_ON | OBJ_2D_MAP);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprInitDat()
{
	s16 i;
	u16* adr = BITMAP_OBJ_BASE_ADR;

	for(i=0; i<2048; i++)
	{
		adr[i] = spr_menuTiles[i];
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprInitPal()
{
	s16 i;

	for(i=0; i<16; i++)
	{
		OBJ_COLORS[i] = spr_menuPal[i];
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprClean()
{
	REG_DMA3SAD = (u32)&dummy;
	REG_DMA3DAD = (u32)OAM;
	REG_DMA3CNT = (u32)sizeof(ST_SPRITE) * 128 / 2 | (DMA_SRC_FIXED | DMA_DST_INC | DMA16 | DMA_ENABLE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprUpdate()
{
	if(Spr.isDraw == TRUE)
	{
		ST_SPRITE* pOam = (ST_SPRITE*)OAM + 0;

		pOam->attr0 = SprCur.attr0;
		pOam->attr1 = SprCur.attr1;
		pOam->attr2 = SprCur.attr2;

		Spr.isDraw = FALSE;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE bool SprSetCur(s16 x, s16 y)
{
	// TODO ͈̓`FbN

	SprCur.attr0 = (y & 0x00ff) | ATTR0_COLOR_16 | ATTR0_NORMAL;
	SprCur.attr1 = (x & 0x01ff) | ATTR1_SIZE_16;
	SprCur.attr2 = SPR_CUR_TILE_NUM | ATTR2_PRIORITY(0);

	Spr.isDraw = TRUE;
	return TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetVerti(s16 ofsY)
{
	Spr.ofsY = ofsY;
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetHoriz(s16 ofsX)
{
	Spr.ofsX = ofsX;
}
