#include "view.h"
#include "libmy/key.h"
#include "libmy/gbfs.h"
#include "libmy/mem.h"
#include "libmy/mode3.h"

//---------------------------------------------------------------------------
ST_VIEW View;


//---------------------------------------------------------------------------
EWRAM_CODE void ViewInit()
{
	_Memset(&View, 0x00, sizeof(ST_VIEW));

	u16 cnt = GbfsGetArcCnt();

	if(cnt == 0)
	{
		SystemError("[Err] MenuInit ArcCnt == 0");
	}

	View.cnt  = cnt;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ViewDraw()
{
	
}
//---------------------------------------------------------------------------
EWRAM_CODE void ViewExec()
{
	u16 key = KeyGetRep();

	if(key == KEY_NONE)
	{
		return;
	}

	if(key & KEY_LEFT)
	{
		if(View.num == 0)
		{
			return;
		}

		View.num--;
	}
	else if(key & KEY_RIGHT)
	{
		if(View.num+1 >= View.cnt)
		{
			return;
		}

		View.num++;
	}

	u16*  pImg  = GbfsGetSafePointer2(View.num);
	char* pName = GbfsGetFileName();

	char buf[64];
	_Sprintf(buf, "[%3d/%3d] %s", View.num, View.cnt, pName);


	Mode3DrawLz77(pImg);
	Mode3SetLocate(0, 13);

//	Mode3DrawFillBox(0, 149, 240, 11, RGB(0,0,0));
	Mode3DrawStr(buf);
}
